--------------------------------------------------------------------------------
--  
-- Engineer: Quintin Immelman
--
-- Create Date:    22:14:53 09/02/05
-- Design Name:    VGA Text example "FPGAs Are Fun"
-- Module Name:    VGA_Module - ClockModule
-- Project Name:   
-- Target Device:  Spartan 3, Should be device independent...
-- Tool versions:  ISE Webpack 7.1i R4
-- Description:	 Small introduction to VGA Text
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity VGA_Module is
    Port ( clk50_in : in std_logic;
           Red_out : out std_logic;
           Green_out : out std_logic;
           Blue_out : out std_logic;
           hs_out : out std_logic;
           vs_out : out std_logic);
end VGA_Module;

architecture Behavioral of VGA_Module is
		signal Clk25					: std_logic;
		signal Horizontal_Counter	: std_logic_vector (9 downto 0);
		signal Vertical_Counter		: std_logic_vector (9 downto 0);

begin
--Generate 25Mhz Clock
process (clk50_in)
begin
	if clk50_in'event and clk50_in='1' then
	  if (Clk25 = '0')then
	    Clk25 <= '1' after 2 ns;
	  else
	    Clk25 <= '0' after 2 ns;
		end if;
	end if;
end process;		  

process (Clk25)
TYPE Screen_Line1 is ARRAY(0 to 7, 0 to 81) OF std_logic;
 
CONSTANT char_L1 : Screen_Line1 := (( '0','1','1','1','1','1','1','1','1','1','1','1','1','0','0','0','0','1','1','1','0','1','0','0','0','0','1','1','0','0','0','0','0','0','0','0','0','0','0','0','0','0','1','1','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','1','1','1','1','1','1','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0'),
										  		( '0','0','1','1','0','0','1','0','1','1','0','0','1','1','0','0','1','1','0','0','1','1','0','0','0','0','1','1','0','0','0','0','0','0','0','0','0','0','0','0','0','0','1','1','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','1','1','0','0','1','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0'),
										  		( '0','0','1','1','0','1','0','0','1','1','0','0','1','1','0','1','1','0','0','0','0','1','0','0','0','0','1','1','1','0','0','0','0','0','0','0','0','0','0','0','0','0','1','1','1','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','1','1','0','1','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0'),
										  		( '0','0','1','1','1','1','0','0','1','1','0','0','1','1','0','1','1','0','0','0','0','0','0','0','0','1','0','1','1','0','0','0','1','1','1','0','0','0','0','0','0','1','0','1','1','0','0','1','1','1','1','1','0','1','1','1','0','0','0','0','0','0','1','1','1','1','0','1','1','1','0','1','1','0','1','1','1','1','1','0','0','0'),
										  		( '0','0','1','1','0','1','0','0','1','1','1','1','1','0','0','1','1','0','0','0','0','0','0','0','0','1','1','1','1','0','0','1','1','0','1','0','0','0','0','0','0','1','1','1','1','0','0','0','1','1','0','1','1','1','0','1','1','0','0','0','0','0','1','1','0','1','0','0','1','1','0','1','1','0','0','1','1','0','1','1','0','0'),
										  		( '0','0','1','1','0','0','0','0','1','1','0','0','0','0','0','1','1','0','0','1','1','1','1','0','1','0','0','0','1','1','0','0','1','1','0','0','0','0','0','0','1','0','0','0','1','1','0','0','1','1','0','0','1','1','1','1','1','0','0','0','0','0','1','1','0','0','0','0','1','1','0','1','1','0','0','1','1','0','1','1','0','0'),
										  		( '0','0','1','1','0','0','0','0','1','1','0','0','0','0','0','0','1','1','0','0','1','1','0','0','1','0','0','0','1','1','0','1','0','1','1','0','0','0','0','0','1','0','0','0','1','1','0','0','1','1','0','0','1','1','0','0','0','0','0','0','0','0','1','1','0','0','0','0','1','1','0','1','1','0','0','1','1','0','1','1','0','0'),
										  		( '0','1','1','1','1','0','0','1','1','1','1','0','0','0','0','0','0','1','1','1','1','0','0','1','1','1','0','1','1','1','1','1','1','1','0','0','0','0','0','1','1','1','0','1','1','1','1','1','1','1','1','0','0','1','1','1','1','0','0','0','0','1','1','1','1','0','0','0','0','1','1','1','1','1','1','1','1','0','1','1','1','0') );
							
variable Line:integer:=0;
variable Pixel:integer:=0;

	begin
		if Clk25'event and Clk25 = '1' then
			if (Horizontal_Counter >= "0010010000" ) -- 144
			and (Horizontal_Counter < "1100010000" ) -- 784
			and (Vertical_Counter >= "0000100111" ) -- 39
    		and (Vertical_Counter < "1000000111" ) -- 519
			then
				Red_out <= '0';
				Green_out <= '0';
				Blue_out <='0';
				-----Line 1	
			  	  if (Horizontal_Counter >=  "0110100111" )--423
				  and (Horizontal_Counter <= "0111111001")--	505
				  and (Vertical_Counter >=	"0011101100") --236
				  and (Vertical_Counter <= "0011110011") then -- 243
				  	if(Pixel <= 81) then --Line 1 Lets make our Text WHITE
				  		 Red_out <= char_L1(Line, Pixel);
						 Green_out <= char_L1(Line, Pixel);
						 Blue_out <= char_L1(Line, Pixel);
						 Pixel:= Pixel+1;
				 	 elsif(Pixel >= 82) then  -- All else BLACK
				  		Red_out <= '0';
						Green_out <= '0';
						Blue_out <= '0';
				  	end if;
					end if;
					end if;
			if (Horizontal_Counter > "0000000000" )
      		and (Horizontal_Counter < "0001100001" ) -- 96+1
    			then
			  		hs_out <= '0';
    			else
      	  		hs_out <= '1';
    		end if;
			if (Vertical_Counter > "0000000000" )
      		and (Vertical_Counter < "0000000011" ) -- 2+1
    			then
      			vs_out <= '0';
    			else
      			vs_out <= '1';
    		end if;

			Horizontal_Counter <= Horizontal_Counter+"0000000001";
    		if (Horizontal_Counter="1100100000") then
      		Vertical_Counter <= Vertical_Counter+"0000000001";
      		Horizontal_Counter <= "0000000000";
				Pixel:= 0;
				if (Vertical_Counter >=	"0011101100") -- First Line
				   and (Vertical_Counter <= "0011110011") then 
						if (Line <= 7) then
				  		Line:= Line+1;
						elsif (Line >= 8) then
				 		 Line:= 0;
						end if;
				 end if;
    		end if;
    		if (Vertical_Counter="1000001001") then		    
      		Vertical_Counter <= "0000000000";
				Line:= 0;
    		end if;
  		end if;
	end process;	 
end Behavioral;
